package customtest.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "customtest.example", "customtest.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "customtest.example", "customtest.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "customtest.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public customtest.example.customlistview _customlist1 = null;
public anywheresoftware.b4a.objects.collections.List _testlist = null;
public static int _i = 0;
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"customlist1",mostCurrent._customlist1,"i",_i,"testlist",mostCurrent._testlist};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
try {
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent,27);
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 27;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(67108864);
 BA.debugLineNum = 28;BA.debugLine="testlist.Initialize";
Debug.ShouldStop(134217728);
mostCurrent._testlist.Initialize();
 BA.debugLineNum = 29;BA.debugLine="testlist.AddAll(Array As String(\"one\",\"two\",\"three\",\"four\",\"five\",\"six\",\"seven\",\"eight\",\"nine\",\"ten\",\"eleven\",\"twelve\",\"thirteen\",\"fourteen\",\"fifteen\"))";
Debug.ShouldStop(268435456);
mostCurrent._testlist.AddAll(anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{"one","two","three","four","five","six","seven","eight","nine","ten","eleven","twelve","thirteen","fourteen","fifteen"}));
 BA.debugLineNum = 30;BA.debugLine="customlist1.Initialize(Me, \"customlist1\")";
Debug.ShouldStop(536870912);
mostCurrent._customlist1._initialize(mostCurrent.activityBA,main.getObject(),"customlist1");
 BA.debugLineNum = 31;BA.debugLine="Activity.AddView(customlist1.AsView, 0%x, 20%y, 100%x, 80%y)";
Debug.ShouldStop(1073741824);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._customlist1._asview().getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (0),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (20),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (80),mostCurrent.activityBA));
 BA.debugLineNum = 32;BA.debugLine="For i = 0 To testlist.Size-1";
Debug.ShouldStop(-2147483648);
{
final int step12 = 1;
final int limit12 = (int) (mostCurrent._testlist.getSize()-1);
for (_i = (int) (0); (step12 > 0 && _i <= limit12) || (step12 < 0 && _i >= limit12); _i = ((int)(0 + _i + step12))) {
 BA.debugLineNum = 33;BA.debugLine="customlist1.add(createlibitem(testlist.Get(i),customlist1.AsView.Width, 50dip),50dip, \"item #\" & i)";
Debug.ShouldStop(1);
mostCurrent._customlist1._add(_createlibitem(BA.ObjectToString(mostCurrent._testlist.Get(_i)),mostCurrent._customlist1._asview().getWidth(),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50)),(Object)("item #"+BA.NumberToString(_i)));
 }
};
 BA.debugLineNum = 35;BA.debugLine="End Sub";
Debug.ShouldStop(4);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static anywheresoftware.b4a.objects.PanelWrapper  _createlibitem(String _text,int _width,int _height) throws Exception{
try {
		Debug.PushSubsStack("createlibitem (main) ","main",0,mostCurrent.activityBA,mostCurrent,37);
anywheresoftware.b4a.objects.PanelWrapper _p = null;
anywheresoftware.b4a.objects.LabelWrapper _bpart = null;
anywheresoftware.b4a.objects.EditTextWrapper _partbox = null;
Debug.locals.put("text", _text);
Debug.locals.put("width", _width);
Debug.locals.put("height", _height);
 BA.debugLineNum = 37;BA.debugLine="Sub createlibitem(text As String, width As Int, height As Int) As Panel";
Debug.ShouldStop(16);
 BA.debugLineNum = 38;BA.debugLine="Dim p As Panel";
Debug.ShouldStop(32);
_p = new anywheresoftware.b4a.objects.PanelWrapper();Debug.locals.put("p", _p);
 BA.debugLineNum = 39;BA.debugLine="p.Initialize(\"\")";
Debug.ShouldStop(64);
_p.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 40;BA.debugLine="p.Color = Colors.Black";
Debug.ShouldStop(128);
_p.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 41;BA.debugLine="Dim bpart As Label";
Debug.ShouldStop(256);
_bpart = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("bpart", _bpart);
 BA.debugLineNum = 42;BA.debugLine="bpart.Initialize(\"button\")";
Debug.ShouldStop(512);
_bpart.Initialize(mostCurrent.activityBA,"button");
 BA.debugLineNum = 43;BA.debugLine="bpart.Color = Colors.ARGB(125,100,149,237)";
Debug.ShouldStop(1024);
_bpart.setColor(anywheresoftware.b4a.keywords.Common.Colors.ARGB((int) (125),(int) (100),(int) (149),(int) (237)));
 BA.debugLineNum = 44;BA.debugLine="Dim partbox As EditText";
Debug.ShouldStop(2048);
_partbox = new anywheresoftware.b4a.objects.EditTextWrapper();Debug.locals.put("partbox", _partbox);
 BA.debugLineNum = 45;BA.debugLine="partbox.Initialize(\"boxes\")";
Debug.ShouldStop(4096);
_partbox.Initialize(mostCurrent.activityBA,"boxes");
 BA.debugLineNum = 46;BA.debugLine="partbox.TextSize = 24";
Debug.ShouldStop(8192);
_partbox.setTextSize((float) (24));
 BA.debugLineNum = 47;BA.debugLine="partbox.Color = -9868951";
Debug.ShouldStop(16384);
_partbox.setColor((int) (-9868951));
 BA.debugLineNum = 48;BA.debugLine="partbox.SingleLine=True";
Debug.ShouldStop(32768);
_partbox.setSingleLine(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 49;BA.debugLine="partbox.ForceDoneButton=True";
Debug.ShouldStop(65536);
_partbox.setForceDoneButton(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 50;BA.debugLine="bpart.Gravity= Bit.OR(Gravity.CENTER_VERTICAL, Gravity.center_horizontal)";
Debug.ShouldStop(131072);
_bpart.setGravity(anywheresoftware.b4a.keywords.Common.Bit.Or(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL,anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL));
 BA.debugLineNum = 51;BA.debugLine="bpart.TextSize = 24";
Debug.ShouldStop(262144);
_bpart.setTextSize((float) (24));
 BA.debugLineNum = 52;BA.debugLine="bpart.text = text";
Debug.ShouldStop(524288);
_bpart.setText((Object)(_text));
 BA.debugLineNum = 53;BA.debugLine="bpart.TextColor=Colors.white";
Debug.ShouldStop(1048576);
_bpart.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 BA.debugLineNum = 54;BA.debugLine="p.AddView(bpart, 0dip, 2dip, 190dip, height-4dip)";
Debug.ShouldStop(2097152);
_p.AddView((android.view.View)(_bpart.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (0)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (2)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (190)),(int) (_height-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))));
 BA.debugLineNum = 55;BA.debugLine="p.AddView(partbox, 190dip, 2dip, 170dip, height-4dip)";
Debug.ShouldStop(4194304);
_p.AddView((android.view.View)(_partbox.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (190)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (2)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (170)),(int) (_height-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))));
 BA.debugLineNum = 56;BA.debugLine="Return p";
Debug.ShouldStop(8388608);
if (true) return _p;
 BA.debugLineNum = 57;BA.debugLine="End Sub";
Debug.ShouldStop(16777216);
return null;
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 46210, new int[] {2, 7}, "19087211-abda-4c2d-b9f2-3fa6ec69ba76");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 22;BA.debugLine="Dim customlist1 As CustomListView";
mostCurrent._customlist1 = new customtest.example.customlistview();
 //BA.debugLineNum = 23;BA.debugLine="Dim testlist As List";
mostCurrent._testlist = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 24;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
}
